Start your migration or new app development today! Apps with over 100 users can submit for verification starting on March 30th.
To ensure a seamless experience for your users, we recommend waiting until the end of May 2026 to officially launch your integration to align with legacy Fitbit account deprecation. Please be aware that from now until the end of May, breaking changes may occur as we respond to developer feedback.
Method: users.dataTypes.dataPoints.list
Stay organized with collections
Save and categorize content based on your preferences.
Query user health and fitness data points.
HTTP request
GET https://health.googleapis.com/v4/{parent=users/*/dataTypes/*}/dataPoints
The URL uses gRPC Transcoding syntax. To know more about valid error responses that can be thrown by this HTTP request, please refer to the service error catalog
Path parameters
| Parameters |
parent |
string
Required. Parent data type of the Data Point collection. Format: users/me/dataTypes/{dataType}, e.g.:
users/me/dataTypes/steps
users/me/dataTypes/weight
For a list of the supported data types see the DataPoint data union field. It takes the form users/{user}/dataTypes/{datatype}.
|
Query parameters
| Parameters |
pageSize |
integer
Optional. The maximum number of data points to return. If unspecified, at most 1440 data points will be returned. The maximum page size is 10000; values above that will be truncated accordingly. For exercise and sleep the default page size is 25. The maximum page size for exercise and sleep is 25.
|
pageToken |
string
Optional. The nextPageToken from a previous request, if any.
|
filter |
string
Optional. Filter expression following https://google.aip.dev/160. A time range (either physical or civil) can be specified. The supported filter fields are:
Interval start time:
- Pattern:
{interval_data_type}.interval.start_time
- Supported comparison operators:
>=, <
- Timestamp literal expected in RFC-3339 format
- Supported logical operators:
AND
- Example:
steps.interval.start_time >= "2023-11-24T00:00:00Z" AND
steps.interval.start_time < "2023-11-25T00:00:00Z"
distance.interval.start_time >= "2024-08-14T12:34:56Z"
Interval civil start time:
- Pattern:
{interval_data_type}.interval.civil_start_time
- Supported comparison operators:
>=, <
- Date with optional time literal expected in ISO 8601
YYYY-MM-DD[THH:mm:ss] format
- Supported logical operators:
AND
- Example:
steps.interval.civil_start_time >= "2023-11-24" AND
steps.interval.civil_start_time < "2023-11-25"
distance.interval.civil_start_time >= "2024-08-14T12:34:56"
Sample observation physical time:
- Pattern:
{sample_data_type}.sample_time.physical_time
- Supported comparison operators:
>=, <
- Timestamp literal expected in RFC-3339 format
- Supported logical operators:
AND
- Example:
weight.sample_time.physical_time >= "2023-11-24T00:00:00Z"
AND weight.sample_time.physical_time < "2023-11-25T00:00:00Z"
weight.sample_time.physical_time >=
"2024-08-14T12:34:56Z"
Sample observation civil time:
- Pattern:
{sample_data_type}.sample_time.civil_time
- Supported comparison operators:
>=, <
- Date with optional time literal expected in ISO 8601
YYYY-MM-DD[THH:mm:ss] format
- Supported logical operators:
AND
- Example:
weight.sample_time.civil_time >= "2023-11-24" AND
weight.sample_time.civil_time < "2023-11-25"
weight.sample_time.civil_time >= "2024-08-14T12:34:56"
Daily summary date:
- Pattern:
{daily_summary_data_type}.date
- Supported comparison operators:
>=, <
- Date literal expected in ISO 8601
YYYY-MM-DD format
- Supported logical operators:
AND
- Example:
dailyRestingHeartRate.date >= "2024-08-14"
dailyHeartRateVariability.date < "2024-08-15"
Session civil start time (**Excluding Sleep**):
- Pattern:
{session_data_type}.interval.civil_start_time
- Supported comparison operators:
>=, <
- Date with optional time literal expected in ISO 8601
YYYY-MM-DD[THH:mm:ss] format
- Supported logical operators:
AND
- Example:
exercise.interval.civil_start_time >= "2023-11-24" AND
exercise.interval.civil_start_time < "2023-11-25"
exercise.interval.civil_start_time >= "2024-08-14T12:34:56"
Session end time (**Sleep specific**):
- Pattern:
sleep.interval.end_time
- Supported comparison operators:
>=, <
- Timestamp literal expected in RFC-3339 format
- Supported logical operators:
AND, OR
- Example:
sleep.interval.end_time >= "2023-11-24T00:00:00Z" AND
sleep.interval.end_time < "2023-11-25T00:00:00Z"
Session civil end time (**Sleep specific**):
- Pattern:
sleep.interval.civil_end_time
- Supported comparison operators:
>=, <
- Date with optional time literal expected in ISO 8601
YYYY-MM-DD[THH:mm:ss] format
- Supported logical operators:
AND, OR
- Example:
sleep.interval.civil_end_time >= "2023-11-24" AND
sleep.interval.civil_end_time < "2023-11-25"
Data points in the response will be ordered by the interval start time in descending order.
|
Request body
The request body must be empty.
Response body
Response containing raw data points matching the query
If successful, the response body contains data with the following structure:
| JSON representation |
{
"dataPoints": [
{
object (DataPoint)
}
],
"nextPageToken": string
} |
| Fields |
dataPoints[] |
object (DataPoint)
Data points matching the query
|
nextPageToken |
string
Next page token, empty if the response is complete
|
Authorization scopes
Requires one of the following OAuth scopes:
https://www.googleapis.com/auth/googlehealth.activity_and_fitness
https://www.googleapis.com/auth/googlehealth.activity_and_fitness.readonly
https://www.googleapis.com/auth/googlehealth.health_metrics_and_measurements
https://www.googleapis.com/auth/googlehealth.health_metrics_and_measurements.readonly
https://www.googleapis.com/auth/googlehealth.location
https://www.googleapis.com/auth/googlehealth.location.readonly
https://www.googleapis.com/auth/googlehealth.nutrition
https://www.googleapis.com/auth/googlehealth.nutrition.readonly
https://www.googleapis.com/auth/googlehealth.sleep
https://www.googleapis.com/auth/googlehealth.sleep.readonly
For more information, see the OAuth 2.0 Overview.
Except as otherwise noted, the content of this page is licensed under the Creative Commons Attribution 4.0 License, and code samples are licensed under the Apache 2.0 License. For details, see the Google Developers Site Policies. Java is a registered trademark of Oracle and/or its affiliates.
Last updated 2026-03-24 UTC.
[[["Easy to understand","easyToUnderstand","thumb-up"],["Solved my problem","solvedMyProblem","thumb-up"],["Other","otherUp","thumb-up"]],[["Missing the information I need","missingTheInformationINeed","thumb-down"],["Too complicated / too many steps","tooComplicatedTooManySteps","thumb-down"],["Out of date","outOfDate","thumb-down"],["Samples / code issue","samplesCodeIssue","thumb-down"],["Other","otherDown","thumb-down"]],["Last updated 2026-03-24 UTC."],[],[]]